/*
Copyright 2003/2004, Freie Universitaet Berlin. All rights reserved.

These sources were developed at the Freie Universitt Berlin, Computer
Systems and Telematics group.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

- Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
 
- Neither the name of Freie Universitaet Berlin (FUB) nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

This software is provided by FUB and the contributors on an "as is"
basis, without any representations or warranties of any kind, express
or implied including, but not limited to, representations or
warranties of non-infringement, merchantability or fitness for a
particular purpose. In no event shall FUB or contributors be liable
for any direct, indirect, incidental, special, exemplary, or
consequential damages (including, but not limited to, procurement of
substitute goods or services; loss of use, data, or profits; or
business interruption) however caused and on any theory of liability,
whether in contract, strict liability, or tort (including negligence
or otherwise) arising in any way out of the use of this software, even
if advised of the possibility of such damage.

This implementation was developed by the CST group at the FUB.
Contributors: Hartmut Ritter

For documentation and questions please use the web site
http://scatterweb.mi.fu-berlin.de and the mailinglist
scatterweb@lists.spline.inf.fu-berlin.de (subscription via the Website).
Berlin, 2003/2004/2005
*/

#ifndef ScatterWeb_DiffusionRouting
#define ScatterWeb_DiffusionRouting

#define TERM_CMD 0x10

#define ROUTING_MESSAGE_FLAG_INFORMATIONAL 1
#define ROUTING_MESSAGE_FLAG_NO_ENTRY 2
#define ROUTING_MESSAGE_FLAG_COMMAND 4

struct RouteInfoStruct {
  unsigned int id;
  char flags;
};

struct RoutingEntryStruct{
  unsigned int id;
  unsigned int next_hop;
  char flags;
};

struct RoutablePacketHeaderStruct{
  unsigned int final_dest;                 ///< Destination.
  unsigned int orig;               ///< Source 
  unsigned char type;               ///< Packet type.
};

int DiffusionRouting_init();

int DiffusionRouting_updateRoutingTable(unsigned int, unsigned int);
//id, next_hop
int Diffusion_Routing_lookupRoutingTable(unsigned int, unsigned int, unsigned int*);
//srcid, id, next_hop
int DiffusionRouting_sendRoutablePacket(packet_t*, fp_char_t);

int DiffusionRouting_sendRoutable(unsigned int, unsigned int, unsigned char, unsigned char*, unsigned int, unsigned char*, unsigned int, fp_char_t);
//orig_src, final_dest, inner_type, header, header_length, data, data_length, callback
int DiffusionRouting_handleRoutablePacket(unsigned int*, unsigned int*, unsigned char*, unsigned int); 
//dstid, srcid, payload, data_length

void term_rrt();

#endif
