/*
 * SerialEval.java
 *
 * Created on 26. Januar 2005, 14:02
 */

/*

        // ID          DEZ                          DESC
        // --------------------------------------------------
        // 0xF0F0       61680 = (240,240)           PICTURE DONE
        // 0xFFFF       65535 = (256,256)           ERROR
        // 0xF0F1       61681 = (240,241)           ????
        //
        // data[0] = id higher 8bits
        // data[1] = id lower 8bits
        // data[2] = length higher 8bits
        // data[3] = length lower 8bits
*/        

package CommTest;

import java.util.Vector;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;

/**
 *
 * @author  schran
 */
public class SerialEval 
{
    private String outputString = "";
    private Vector pictureBytes;
    private byte jpgBuffer[];
    private byte binLine[] = null;          // one line for picture
    private int  binPos = 0;                // current index in binLine
    private boolean error = false;
    private int currentSize = 0;
    
    private boolean picReady = false;
    
    /** Creates a new instance of PictureReader */
    public SerialEval() 
    {
        pictureBytes = new Vector();
    }
    
    // evaluate a character read from serial port
    public void eval(int b)
    {
        char ch = (char) b;
        
        // start of a binary line: prepare buffer
        if ((ch == '*') && (binLine == null))
        {   
//            t.setString("New line.");
            binLine = new byte[70]; // enough due to scatterflasher tool
            binPos = 0;
            return;
        }
        
        // actually receiving a line
        if (binLine != null)
        {
            binLine[binPos] = (byte) b;
            binPos++;
            
            // payload
            if (binPos >= 4)
            {
//                int id      = binLine[1]; //+(binLine[0]<<8);
//                int length  = binLine[3]; //+(binLine[2]<<8);
                int id      = binLine[1] + (binLine[0]<<8);
                int length  = binLine[3]; //+(binLine[2]<<8);
                
                // line complete
                // maybe length+4+2: 
                // node seems to send: *, id hi, id lo, len hi, len lo, len lo, len hi, data
                if (binPos == length+4)
                {
                    addLine(binLine);
                    // reset
                    binLine = null;
                    binPos = 0;
                }
                return;
            }
        }
        
        // TODO: other evaluation
    }
    
    // add a binary line to current picture
    public void addLine(byte line[])
    {
        int id0      = line[0];
        int id1      = line[1];
        int length  = line[3]; //+(line[2]<<8);
        
//        outputString += "("+id+","+length+"),";
//        t.setString(outputString);

        // if this line is the last line of the picture
        if ((id0 == -16) && (id1 == -16))
        {
//            outputString += "\n Last line!";
//            t.setString(outputString);
            // create final image buffer
            jpgBuffer = new byte[pictureBytes.size()];
        
            for (int j = 0; j < pictureBytes.size(); j++)
            {
                Byte bt = (Byte) pictureBytes.elementAt(j);
                jpgBuffer[j] = bt.byteValue();
            }
            pictureBytes.removeAllElements();
            picReady = true;
        }
        // normal line
        else
        {
            // ??? length or length+4 ???
            for (int i = 4; i < length+4; i++)
            {
                pictureBytes.addElement(new Byte(line[i]));
            }
        }
    }
    
    public boolean error()
    {
        return error;
    }
    
    public boolean picReady()
    {
        boolean b = picReady;
        picReady = false;
        return b;
    }
    
    public byte[] getPicture()
    {
        return jpgBuffer;
    }
}
