/*
Copyright 2005, Freie Universitaet Berlin. All rights reserved.

These sources were developed at the Freie Universitt Berlin, Computer
Systems and Telematics group.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

- Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
 
- Neither the name of Freie Universitaet Berlin (FUB) nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

This software is provided by FUB and the contributors on an "as is"
basis, without any representations or warranties of any kind, express
or implied including, but not limited to, representations or
warranties of non-infringement, merchantability or fitness for a
particular purpose. In no event shall FUB or contributors be liable
for any direct, indirect, incidental, special, exemplary, or
consequential damages (including, but not limited to, procurement of
substitute goods or services; loss of use, data, or profits; or
business interruption) however caused and on any theory of liability,
whether in contract, strict liability, or tort (including negligence
or otherwise) arising in any way out of the use of this software, even
if advised of the possibility of such damage.

This implementation was developed by the CST group at the FUB.

For documentation and questions please use the web site
http://scatterweb.mi.fu-berlin.de and the mailinglist
scatterweb@lists.spline.inf.fu-berlin.de (subscription via the Website).
Berlin, 2005
*/

/** \file ScatterWeb.RVC.h
 ** \ingroup Applications
 ** \brief Methods for handling Remote Variable Calling (RVC).
 **
 ** @author        Marco Hutta
 ** @version       2.2
 ** @since         2.2
 **/ 
    
#ifndef ScatterWeb_RVC
#define ScatterWeb_RVC

#include "../../../../System/src/ScatterWeb.System.h"

// Variables of ScatterWeb.Comm
#define COMM_LOGLEVEL                              1

// Variables of ScatterWeb.Configuration
#define CONFIGURATION_CONFIGURATION_ID             2
#define CONFIGURATION_CONFIGURATION_RXRECEIVELIMIT 3
#define CONFIGURATION_CONFIGURATION_TRANSMITPOWER  4
#define CONFIGURATION_CONFIGURATION_BOOT_LOGLEVEL  5
#define CONFIGURATION_CONFIGURATION_PANICFLAGS     6
#define CONFIGURATION_CONFIGURATION_FIRMWAREFLAGS  7

// Variables of ScatterWeb.Data
#define DATA_SENSORFLAGS                           8

// Variables of ScatterWeb.IO

// Variables of ScatterWeb.Messaging
#define MESSAGING_TERM_REPLY                       9

// Variables of ScatterWeb.Net
#define NET_RXPACKET_TO                            10
#define NET_RXPACKET_FROM                          11
#define NET_RXPACKET_TYPE                          12
#define NET_RXPACKET_NUM                           13
#define NET_RXPACKET_HEADER                        14
#define NET_RXPACKET_HERDER_LENGTH                 15
#define NET_RXPACKET_DATA                          16
#define NET_RXPACKET_DATA_LENGTH                   17
#define NET_SENTPACKET_TO                          18
#define NET_SENTPACKET_FROM                        19
#define NET_SENTPACKET_TYPE                        20
#define NET_SENTPACKET_NUM                         21
#define NET_SENTPACKET_HEADER                      22
#define NET_SENTPACKET_HEADER_LENGTH               23
#define NET_SENTPACKET_DATA                        24
#define NET_SENTPACKET_DATA_LENGTH                 25
#define NET_TXRETRIES                              26
#define NET_CDCOUNTER                              27
#define NET_TXSTATE                                28

// Variables of ScatterWeb.String

// Variables of ScatterWeb.Synchronisation
#define SYNCHRONISATION_SYNCSTRUCT_SEQNUM          29
#define SYNCHRONISATION_SYNCSTRUCT_MASTERROOTID    30
#define SYNCHRONISATION_SYNCSTRUCT_SYNCPERIODS     31

// Variables of ScatterWeb.System
#define SYSTEM_CALLBACKS                           32
#define SYSTEM_RUNMODULE                           33
#define SYSTEM_RXPTEMP                             34
#define SYSTEM_RXPVALUE                            35
#define SYSTEM_MIC                                 36

// Variables of ScatterWeb.Threading
#define THREADING_THREADING_CURRENTTHREAD          37

// Variables of ScatterWeb.Time

// Variables of ScatterWeb.Timers

#endif
