/*
Copyright 2003/2004, Freie Universitaet Berlin. All rights reserved.

These sources were developed at the Freie Universitt Berlin, Computer
Systems and Telematics group.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

- Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
 
- Neither the name of Freie Universitaet Berlin (FUB) nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

This software is provided by FUB and the contributors on an "as is"
basis, without any representations or warranties of any kind, express
or implied including, but not limited to, representations or
warranties of non-infringement, merchantability or fitness for a
particular purpose. In no event shall FUB or contributors be liable
for any direct, indirect, incidental, special, exemplary, or
consequential damages (including, but not limited to, procurement of
substitute goods or services; loss of use, data, or profits; or
business interruption) however caused and on any theory of liability,
whether in contract, strict liability, or tort (including negligence
or otherwise) arising in any way out of the use of this software, even
if advised of the possibility of such damage.

This implementation was developed by the CST group at the FUB.
Contributors: Bjoern Lichtblau

For documentation and questions please use the web site
http://www.scatterweb.net and the mailinglist
scatterweb@lists.spline.inf.fu-berlin.de (subscription via the Website).
Berlin, 2003/2004
*/

#ifndef _FLASHERH_
#define _FLASHERH_

#include "../../src/ScatterWeb.System.h"

/// \name Public interface
//@{


/*
void flasher_si_start(UINT8 target); ///< Flashing a single device.
void flasher_mu_start(UINT16* ts, UINT16 length); ///< Flashing multiple devices.
*/
//@}

/// \name Firmware entry functions.
//@{
void flasher_start(UINT16* targets, UINT8 length);

void handle_FLASH_HEADER();   ///< Packet handler.

void printImageData(const imageData_t* i);
void flasher_init();
//@}

#define FH_OK     (0x0001)
#define FH_NP     (0x0002)
#define FH_BUSY   (0x0003)
#define FH_MM     (0x0004)

void flasher_flx(char* str);

void flasher_est();

void flasher_fst();

#endif
